diff --git a/django/views/csrf.py b/django/views/csrf.py
index c95d19d..ba9c0b5 100644
--- a/django/views/csrf.py
+++ b/django/views/csrf.py
@@ -1,10 +1,12 @@
+from django.conf import settings
 from django.http import HttpResponseForbidden
 from django.template import Context, Template
-from django.conf import settings
+from django.utils.translation import ugettext as _
 
 # We include the template inline since we need to be able to reliably display
 # this error message, especially for the sake of developers, and there isn't any
 # other way of making it available independent of what is in the settings file.
+# Only the text appearing with DEBUG=False is translated.
 
 CSRF_FAILURE_TEMPLATE = """
 <!DOCTYPE html>
@@ -20,7 +22,7 @@ CSRF_FAILURE_TEMPLATE = """
     body { font:small sans-serif; background:#eee; }
     body>div { border-bottom:1px solid #ddd; }
     h1 { font-weight:normal; margin-bottom:.4em; }
-    h1 span { font-size:60%; color:#666; font-weight:normal; }
+    h1 span { font-size:60%%; color:#666; font-weight:normal; }
     #info { background:#f6f6f6; }
     #info ul { margin: 0.5em 4em; }
     #info p, #summary p { padding-top:10px; }
@@ -30,28 +32,23 @@ CSRF_FAILURE_TEMPLATE = """
 </head>
 <body>
 <div id="summary">
-  <h1>Forbidden <span>(403)</span></h1>
-  <p>CSRF verification failed. Request aborted.</p>
-{% if no_referer %}
-  <p>You are seeing this message because this HTTPS site requires a 'Referer
-   header' to be sent by your Web browser, but none was sent. This header is
-   required for security reasons, to ensure that your browser is not being
-   hijacked by third parties.</p>
+  <h1>%(title)s <span>(403)</span></h1>
+  <p>%(main)s</p>
+{%% if no_referer %%}
+  <p>%(no_referer1)s</p>
 
-  <p>If you have configured your browser to disable 'Referer' headers, please
-   re-enable them, at least for this site, or for HTTPS connections, or for
-   'same-origin' requests.</p>
-{% endif %}
+  <p>%(no_referer2)s</p>
+{%% endif %%}
 </div>
-{% if DEBUG %}
+{%% if DEBUG %%}
 <div id="info">
   <h2>Help</h2>
-    {% if reason %}
+    {%% if reason %%}
     <p>Reason given for failure:</p>
     <pre>
     {{ reason }}
     </pre>
-    {% endif %}
+    {%% endif %%}
 
   <p>In general, this can occur when there is a genuine Cross Site Request Forgery, or when
   <a
@@ -66,8 +63,8 @@ CSRF_FAILURE_TEMPLATE = """
     href='http://docs.djangoproject.com/en/dev/ref/templates/api/#subclassing-context-requestcontext'><code>RequestContext</code></a>
     for the template, instead of <code>Context</code>.</li>
 
-    <li>In the template, there is a <code>{% templatetag openblock %} csrf_token
-    {% templatetag closeblock %}</code> template tag inside each POST form that
+    <li>In the template, there is a <code>{%% templatetag openblock %%} csrf_token
+    {%% templatetag closeblock %%}</code> template tag inside each POST form that
     targets an internal URL.</li>
 
     <li>If you are not using <code>CsrfViewMiddleware</code>, then you must use
@@ -82,11 +79,11 @@ CSRF_FAILURE_TEMPLATE = """
 
   <p>You can customize this page using the CSRF_FAILURE_VIEW setting.</p>
 </div>
-{% else %}
+{%% else %%}
 <div id="explanation">
-  <p><small>More information is available with DEBUG=True.</small></p>
+  <p><small>%(more)s</small></p>
 </div>
-{% endif %}
+{%% endif %%}
 </body>
 </html>
 """
@@ -96,7 +93,20 @@ def csrf_failure(request, reason=""):
     Default view used when request fails CSRF protection
     """
     from django.middleware.csrf import REASON_NO_REFERER
-    t = Template(CSRF_FAILURE_TEMPLATE)
+    t = Template(CSRF_FAILURE_TEMPLATE % {
+        'title': _("Forbidden"),
+        'main': _("CSRF verification failed. Request aborted."),
+        'no_referer1': _(
+            "You are seeing this message because this HTTPS site requires a 'Referer "
+            "header' to be sent by your Web browser, but none was sent. This header is "
+            "required for security reasons, to ensure that your browser is not being "
+            "hijacked by third parties."),
+        'no_referer2': _(
+            "If you have configured your browser to disable 'Referer' headers, please "
+            "re-enable them, at least for this site, or for HTTPS connections, or for "
+            "'same-origin' requests."),
+        'more': _("More information is available with DEBUG=True."),
+    })
     c = Context({'DEBUG': settings.DEBUG,
                  'reason': reason,
                  'no_referer': reason == REASON_NO_REFERER