diff --git a/django/db/backends/postgresql_psycopg2/introspection.py b/django/db/backends/postgresql_psycopg2/introspection.py
index aef0bf0..a38a13a 100644
--- a/django/db/backends/postgresql_psycopg2/introspection.py
+++ b/django/db/backends/postgresql_psycopg2/introspection.py
@@ -128,7 +128,9 @@ class DatabaseIntrospection(BaseDatabaseIntrospection):
                 kc.constraint_name,
                 kc.column_name,
                 c.constraint_type,
-                array(SELECT table_name::text || '.' || column_name::text FROM information_schema.constraint_column_usage WHERE constraint_name = kc.constraint_name)
+                array(SELECT table_name::text || '.' || column_name::text
+                      FROM information_schema.constraint_column_usage
+                      WHERE constraint_name = kc.constraint_name)
             FROM information_schema.key_column_usage AS kc
             JOIN information_schema.table_constraints AS c ON
                 kc.table_schema = c.table_schema AND
diff --git a/django/db/backends/schema.py b/django/db/backends/schema.py
index db22dba..fd94837 100644
--- a/django/db/backends/schema.py
+++ b/django/db/backends/schema.py
@@ -491,20 +491,28 @@ class BaseDatabaseSchemaEditor(object):
         new_db_params = new_field.db_parameters(connection=self.connection)
         new_type = new_db_params['type']
         if (old_type is None and old_field.rel is None) or (new_type is None and new_field.rel is None):
-            raise ValueError("Cannot alter field %s into %s - they do not properly define db_type (are you using PostGIS 1.5 or badly-written custom fields?)" % (
-                old_field,
-                new_field,
-            ))
+            raise ValueError(
+                "Cannot alter field %s into %s - they do not properly define "
+                "db_type (are you using PostGIS 1.5 or badly-written custom "
+                "fields?)" % (
+                    old_field,
+                    new_field,
+                ),
+            )
         elif old_type is None and new_type is None and (old_field.rel.through and new_field.rel.through and old_field.rel.through._meta.auto_created and new_field.rel.through._meta.auto_created):
             return self._alter_many_to_many(model, old_field, new_field, strict)
         elif old_type is None and new_type is None and (old_field.rel.through and new_field.rel.through and not old_field.rel.through._meta.auto_created and not new_field.rel.through._meta.auto_created):
             # Both sides have through models; this is a no-op.
             return
         elif old_type is None or new_type is None:
-            raise ValueError("Cannot alter field %s into %s - they are not compatible types (you cannot alter to or from M2M fields, or add or remove through= on M2M fields)" % (
-                old_field,
-                new_field,
-            ))
+            raise ValueError(
+                "Cannot alter field %s into %s - they are not compatible types "
+                "(you cannot alter to or from M2M fields, or add or remove "
+                "through= on M2M fields)" % (
+                    old_field,
+                    new_field,
+                )
+            )
 
         self._alter_field(model, old_field, new_field, old_type, new_type, old_db_params, new_db_params, strict)
 
diff --git a/django/utils/lorem_ipsum.py b/django/utils/lorem_ipsum.py
index b91fecf..19bf899 100644
--- a/django/utils/lorem_ipsum.py
+++ b/django/utils/lorem_ipsum.py
@@ -6,7 +6,15 @@ from __future__ import unicode_literals
 
 import random
 
-COMMON_P = 'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.'
+COMMON_P = (
+    'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod '
+    'tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim '
+    'veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea '
+    'commodo consequat. Duis aute irure dolor in reprehenderit in voluptate '
+    'velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint '
+    'occaecat cupidatat non proident, sunt in culpa qui officia deserunt '
+    'mollit anim id est laborum.'
+)
 
 WORDS = ('exercitationem', 'perferendis', 'perspiciatis', 'laborum', 'eveniet',
         'sunt', 'iure', 'nam', 'nobis', 'eum', 'cum', 'officiis', 'excepturi',
diff --git a/django/utils/translation/trans_real.py b/django/utils/translation/trans_real.py
index 5715d57..3d94f22 100644
--- a/django/utils/translation/trans_real.py
+++ b/django/utils/translation/trans_real.py
@@ -618,7 +618,10 @@ def templatize(src, origin=None):
                     filemsg = ''
                     if origin:
                         filemsg = 'file %s, ' % origin
-                    raise SyntaxError("Translation blocks must not include other block tags: %s (%sline %d)" % (t.contents, filemsg, t.lineno))
+                    raise SyntaxError(
+                        "Translation blocks must not include other block tags: "
+                        "%s (%sline %d)" % (t.contents, filemsg, t.lineno)
+                    )
             elif t.token_type == TOKEN_VAR:
                 if inplural:
                     plural.append('%%(%s)s' % t.contents)
diff --git a/setup.cfg b/setup.cfg
index f6a4a2b..5ef789c 100644
--- a/setup.cfg
+++ b/setup.cfg
@@ -4,7 +4,8 @@ install-script = scripts/rpm-install.sh
 
 [flake8]
 exclude=build,.git,./django/utils/dictconfig.py,./django/utils/unittest.py,./django/utils/lru_cache.py,./django/utils/six.py,./django/conf/app_template/*,./django/dispatch/weakref_backports.py
-ignore=E123,E128,E265,E501,W601
+ignore=E123,E128,E265,W601
+max-line-length = 120
 
 [metadata]
 license-file = LICENSE